//
//  ViewController.swift
//  iOSDemoApp
//
//  Created by Sonam Ligade on 7/20/23.
//

import UIKit
import NuanceMessagingUI
import NuanceMessagingCore
import NinaCobra
import NuanceGuide

class ViewController: UIViewController, NuanceMessagingDelegate {

    @IBOutlet weak var launchChat: UIButton!

    var vc: NuanceMessagingViewController = NuanceMessagingViewController()
    var message: GetMessageAPI!
    var engagementParams : EngageParameters {
        getProdEngageParameters()
    }

    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        setProdAPI()
        self.message = GetMessageAPI.getInstance();
    }
    
    @IBAction func tabbed(_ sender: UIButton, forEvent event: UIEvent) {
 
            print("Launching Normal Chat.....")
            
            let isChatInProgress = NuanMessaging.getInstance().getChatProgress()
            if(isChatInProgress) {
                vc = restoreMessagingViewController(webview: nil)
            } else {
                vc = launchMessagingViewController(params: engagementParams)
            }
            vc.modalPresentationStyle = .fullScreen
            self.present(vc, animated: true, completion: nil)
      
    }
    
    
    /**
      To continue receiving agent message while in minimized state and to display a restore button,
      refer the following code snippet
    **/
    override func viewWillAppear(_ animated: Bool) {
        
        DispatchQueue.main.asyncAfter(deadline: .now() + 1) {
                    self.startPolling()
                }
        }
    
    func startPolling(){
        // Check if there is an engagement session in progress
        if(NuanMessaging.getInstance().getChatProgress()) {
        //continue pooling for new agent messages
            self.message.getMessages({ (response, error) in
                
              if(response?.messageType == "chatLine") {
                    ChimeSound.sharedInstance.playSound()
                  print("@@@ Agent messge", response?.getProperty("messageText"))
                }
            })
        }}


     override func viewWillDisappear(_ animated: Bool) {
            if(NuanMessaging.getInstance().getChatProgress()) {
                message.cancelGetMessages()
            }
        }

    
    func setProdAPI() {
//        NuanMessaging.getInstance()?.overrideAPIDomain("https://api-us1.digital.nuance.com");
        
//        NuanMessaging.getInstance()?.overrideAuthDomain("https://auth-us1.digital.nuance.com");
        
        NuanMessaging.getInstance().initialize("", andClientID: "", andClientSecret: "",andTagServerName:"")
    }

    
    func getProdEngageParameters() -> EngageParameters{
        let engage = EngageParameters()
        engage.siteID = ""
        engage.agentGroupID = ""
        engage.businessUnitID = ""
        engage.businessRuleID = ""
//        engage.autoID = 18000492
//        engage.isAsyncEngagement = true
//        engage.asyncMode = "all"
//        engage.customerName = "TestUser007"
//        AsyncTranscriptAPI.shouldStubRM(false)
        return engage;
        
    }
    
}

